package vue;

import controleur.ControleurClavier;
import controleur.ControleurEtoile;
import controleur.ControleurSouris;
import controleur.ControleurTrace;

import java.awt.*;
import javax.swing.JFrame;

public class FenetreDeDessin extends JFrame {
    private Color couleur;
    private BasicStroke pinceau;
    private ControleurSouris controleurTrace, controleurEtoile, controleurCourant;
    public FenetreDeDessin(ControleurClavier contrClavier) {
        setTitle("Une première fenêtre pour dessiner à main levée");
        setSize(600, 500);
        setLocationRelativeTo(null);
        setDefaultCloseOperation(EXIT_ON_CLOSE);
        controleurTrace = new ControleurTrace(this);
        controleurEtoile = new ControleurEtoile(this);
        controleurCourant = controleurTrace;
        addMouseListener(controleurCourant);
        addMouseMotionListener(controleurCourant);
        addKeyListener(contrClavier);
        contrClavier.pour(this);
        pinceau = new BasicStroke(1, BasicStroke.CAP_ROUND, BasicStroke.JOIN_ROUND);
        setVisible(true);
    }
    public void changeEpaisseur(int ep) {
        pinceau = new BasicStroke(ep, BasicStroke.CAP_ROUND, BasicStroke.JOIN_ROUND);
    }
    public void changeCouleur(Color coul) {
        couleur = coul;
    }
    public void dessineSegment(int x1, int y1, int x2, int y2) {
        Graphics g = getGraphics();
        ((Graphics2D)g).setStroke(pinceau);
        g.setColor(couleur);
        g.drawLine(x1, y1, x2, y2);
    }
    private void changePourControleur(ControleurSouris controleurChoisi) {
        removeMouseListener(controleurCourant);
        removeMouseMotionListener(controleurCourant);
        controleurCourant = controleurChoisi;
        addMouseListener(controleurCourant);
        addMouseMotionListener(controleurCourant);
    }
    public void outilTrace() {
        changePourControleur(controleurTrace);
    }
    public void outilEtoile() {
        changePourControleur(controleurEtoile);
    }
}
